﻿using System.ComponentModel.DataAnnotations;
using OpusSuite.Utility;

namespace OpusSuite.Models.Model.Shared
{
    [Table("codelookup")]
    public class CodeLookup : ModelBase
    {
        [Key]
        public int Id { get; set; }

        public int CodeTypeValue { get; set; }
        public Enums.CodeType CodeType
        {
            get { return (Enums.CodeType)CodeTypeValue; }
            set { CodeTypeValue = (int)value; }
        }

        [StringLength(30)]
        public string Code { get; set; }

        [StringLength(256)]
        public string Name { get; set; }

        [StringLength(1024)]
        public string Description { get; set; }
    }
}
