﻿using System.ComponentModel.DataAnnotations;
using System.Collections.Generic;

namespace OpusSuite.Models.Model.Shared
{
    [Table("organisation")]
    public class Organisation : ModelBase, IStaticBase
    {
        [Key]
        public int Id { get; set; }

        [StringLength(30)]
        public string Code { get; set; }

        public virtual ReportingStatus ReportingStatus { get; set; }

        public virtual IList<Contact> Contacts { get; set; }

        public virtual IList<OrganisationAddress> Address { get; set; }

        public virtual IList<OrganisationCommunication> Communications { get; set; }
    }
}
