﻿using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using OpusSuite.Models.Model.Shared;

namespace OpusSuite.Models.Model.Tenant
{
    public class Lessee : ModelBase, IStaticBase
    {
        [Key]
        public int Id { get; set; }

        [StringLength(30)]
        public string Code { get; set; }

        public virtual ReportingStatus ReportingStatus { get; set; }

        public virtual Organisation Organisation { get; set; }

        public virtual Person Person { get; set; }

        public virtual IList<BankAccount> BankAccounts { get; set; }

        public virtual IList<Charge> Charges { get; set; }

        public virtual IList<TenantDeposit> Deposits { get; set; }

    }
}
