﻿using System;
using System.ComponentModel.DataAnnotations;
using OpusSuite.Models.Model.Shared;

namespace OpusSuite.Models.Model.WebAdmin
{
    [Table("usersession")]
    public class UserSession : ModelBase
    {
        public int UserSessionId { get; set; }

        public DateTime LastLoggedInDate { get; set; }

        [StringLength(20)]
        public string LastLoggedInIP { get; set; }
        public bool IsLoggedIn { get; set; }
        public DateTime LoggedInDate { get; set; }

        [StringLength(20)]
        public string LoggedInIP { get; set; }
        public DateTime LoggedOutDate { get; set; }
    }

    [Table("usersessionhistory")]
    public class UserSessionHistory : ModelBase
    {
        public int UserSessionHistoryId { get; set; }

        public virtual User User { get; set; }

        public DateTime LoggedInDate { get; set; }
        public DateTime LoggedOutDate { get; set; }
        [StringLength(20)]
        public string LoggedInIP { get; set; }
    }
}
