﻿
using System.ComponentModel;

namespace OpusSuite.Utility
{
    public static class Enums
    {
        public enum ServerTypes
        {
            [Description("MySQL Server")]
            MySqlServer,
            [Description("SQL Server")]
            SqlServer
        };

        public enum ApplicationMessageLifetime
        {
            Once,
            Seconds,
            Forever
        };

        public enum ApplicationMessageType
        {
            Message,
            Log,
            ValidationMessage
        };

        public enum ApplicationMessageLevel
        {
            Information,
            Warning,
            Error,
            //Timeout
        };

        public enum ModelTypes
        {
            NHibernate,
            EntityFramework
        };

        public enum OpusSuiteResource
        {
            Ref,
            //Shared,
            //WebAdmin,
            Common,
            Setup,
            Logon,
            UserProfile,
            AccountAdmin
        };

        public enum UserStatus
        {
            Current,
            Old,
            Disabled
        };

        public enum UserProfileRoleType
        {
            GeneralUser,
            SystemAdmin,
            Surveyor,
            PropertyManager,
            Accounts
        };

        public enum CommunicationType
        {
            Home,
            Work,
            Other
        };

        public enum CommunicationPhoneType
        {
            Primary,
            Secondary,
            Mobile,
            Other
        };

        public enum CommunicationEmailType
        {
            Primary,
            Secondary,
            Other
        };

        public enum CommunicationFaxType
        {
            Primary,
            Secondary,
            Other
        };

        public enum CommunicationWebsiteType
        {
            Work,
            Personal,
            Link,
            Other
        };

        public enum SettingType
        {
            [Description("Show Tooltips")]
            ShowTooltips
        };

        public enum CodeType
        {
            ResidentialPropertyTenure,
            ResidentialPropertyStatus,
            CommercialPropertyTenure,
            CommericalPropertyStatus,
            CommercialUnitStatus,
            ResidentialUnitStatus,
            ResidentialLeaseTenure,
            ResidentialLeaseStatus,
            CommercialLeaseTenure,
            CommercialLeaseStatus,
        };

    }
}
