﻿(function ($) {
    var dialogDateFormatSettings = {
        'width': 490,
        'title': 'Date Formats',
        'DateFormatCode': null,
        'DateFormatId': null,
        'resizable': true,
        'position': [($(window).size.width / 2) / 245, 10],
        'AutoCompleteElement': null,
        'ApplicationMessagesPartial': null,
        'InputElement': null
    };

    var methods = {
        init: function (options) {

            return this.each(function () {
                var that = $(this);

                if (options) {
                    $.extend(dialogDateFormatSettings, options);
                }

                $('#' + dialogDateFormatSettings.btn).button({
                    icons: {
                        primary: 'ui-icon ui-icon-zoomin'
                    },
                    text: false
                }).bind('click', function (e) {
                    dialogDateFormatSettings.DateFormatCode = $("#" + dialogDateFormatSettings.InputElement).val();
                    dialogDateFormatSettings.DateFormatId = $("#" + dialogDateFormatSettings.InputElement).attr("data-opus-id");
                    methods.open.call(that);
                    e.preventDefault();
                });

                $("#" + dialogDateFormatSettings.AutoCompleteElement).opusAutoComplete({
                    url: '/Ref/DateFormats'
                });

            });
        },
        destroy: function () {
            return this.each(function () {
                $(this).unbind('.selectDateFormat');
            });
        },
        open: function (options) {
            if (options) {
                $.extend(dialogDateFormatSettings, options);
            }

            //return this.each(function () {
            var d = $(this).dialog({
                autoOpen: true,
                width: dialogDateFormatSettings.width,
                position: dialogDateFormatSettings.position,
                resizable: dialogDateFormatSettings.resizable,
                title: dialogDateFormatSettings.title,
                modal: true,
                open: function (event, ui) {
                    $(this).load('/Ref/DateFormatSelect' + '?id=' + dialogDateFormatSettings.DateFormatId);
                },
                buttons: {
                    "Select": function () {
                        if ($("#Dialog_DateFormat_Clear").hasClass('CancelButton')) {
                            alert("Please save or cancel the current operation first");
                        }
                        else {
                            if ($("#Dialog_DateFormat_Description").val() != "") {
                                $.get('/Shared/ApplicationMessages', {}, function (view) {
                                    $("#" + dialogDateFormatSettings.ApplicationMessagesPartial).html(view);
                                });
                                $("#" + dialogDateFormatSettings.InputElement)
                                    .attr('data-opus-id', $("#Dialog_DateFormat_Id").val())
                                    .attr('data-opus-code', $("#Dialog_DateFormat_Code").val())
                                    .val($("#Dialog_DateFormat_Description").val())
                                $(this).dialog("close");
                            }
                            else {
                                alert("Please select a DateFormat first or close the dialog");
                            }
                        }
                    },
                    "Close": function () {
                        if ($("#Dialog_DateFormat_Clear").hasClass('CancelButton')) {
                            alert("Please save or cancel the current operation first");
                        }
                        else {
                            $.get('/Shared/ApplicationMessages', {}, function (view) {
                                $("#" + dialogDateFormatSettings.ApplicationMessagesPartial).html(view);
                            });
                            $(this).dialog("close");
                        }
                    }
                }
            });

            d.bind("dialogresize", function (event, ui) {
                $('#resizeLabel').text('Size: ' + ui.size.width + ',' + ui.size.height);
            });

            return this;
            //});
        }
    };

    $.fn.selectDateFormat = function (method) {
        if (methods[method]) {
            return methods[method].apply(this, Array.prototype.slice.call(arguments, 1));
        } else if (typeof method === 'object' || !method) {
            return methods.init.apply(this, arguments);
        } else {
            $.error('Method ' + method + ' does not exist on jQuery.selectDateFormat');
        }
    };
})(jQuery);
