﻿(function ($) {
    var dialogMoneyFormatSettings = {
        'width': 490,
        'title': 'Money Formats',
        'MoneyFormatCode': null,
        'MoneyFormatId': null,
        'resizable': true,
        'position': [($(window).size.width / 2) / 245, 10],
        'AutoCompleteElement': null,
        'ApplicationMessagesPartial': null,
        'InputElement': null
    };

    var methods = {
        init: function (options) {

            return this.each(function () {
                var that = $(this);

                if (options) {
                    $.extend(dialogMoneyFormatSettings, options);
                }

                $('#' + dialogMoneyFormatSettings.btn).button({
                    icons: {
                        primary: 'ui-icon ui-icon-zoomin'
                    },
                    text: false
                }).bind('click', function (e) {
                    dialogMoneyFormatSettings.MoneyFormatCode = $("#" + dialogMoneyFormatSettings.InputElement).val();
                    dialogMoneyFormatSettings.MoneyFormatId = $("#" + dialogMoneyFormatSettings.InputElement).attr("data-opus-id");
                    methods.open.call(that);
                    e.preventDefault();
                });

                $("#" + dialogMoneyFormatSettings.AutoCompleteElement).opusAutoComplete({
                    url: '/Ref/MoneyFormats'
                });

            });
        },
        destroy: function () {
            return this.each(function () {
                $(this).unbind('.selectMoneyFormat');
            });
        },
        open: function (options) {
            if (options) {
                $.extend(dialogMoneyFormatSettings, options);
            }

            //return this.each(function () {
            var d = $(this).dialog({
                autoOpen: true,
                width: dialogMoneyFormatSettings.width,
                position: dialogMoneyFormatSettings.position,
                resizable: dialogMoneyFormatSettings.resizable,
                title: dialogMoneyFormatSettings.title,
                modal: true,
                open: function (event, ui) {
                    $(this).load('/Ref/MoneyFormatSelect' + '?id=' + dialogMoneyFormatSettings.MoneyFormatId);
                },
                buttons: {
                    "Select": function () {
                        if ($("#Dialog_MoneyFormat_Clear").hasClass('CancelButton')) {
                            alert("Please save or cancel the current operation first");
                        }
                        else {
                            if ($("#Dialog_MoneyFormat_Description").val() != "") {
                                $.get('/Shared/ApplicationMessages', {}, function (view) {
                                    $("#" + dialogMoneyFormatSettings.ApplicationMessagesPartial).html(view);
                                });
                                $("#" + dialogMoneyFormatSettings.InputElement)
                                    .attr('data-opus-id', $("#Dialog_MoneyFormat_Id").val())
                                    .attr('data-opus-code', $("#Dialog_MoneyFormat_Code").val())
                                    .val($("#Dialog_MoneyFormat_Description").val())
                                $(this).dialog("close");
                            }
                            else {
                                alert("Please select a MoneyFormat first or close the dialog");
                            }
                        }
                    },
                    "Close": function () {
                        if ($("#Dialog_MoneyFormat_Clear").hasClass('CancelButton')) {
                            alert("Please save or cancel the current operation first");
                        }
                        else {
                            $.get('/Shared/ApplicationMessages', {}, function (view) {
                                $("#" + dialogMoneyFormatSettings.ApplicationMessagesPartial).html(view);
                            });
                            $(this).dialog("close");
                        }
                    }
                }
            });

            d.bind("dialogresize", function (event, ui) {
                $('#resizeLabel').text('Size: ' + ui.size.width + ',' + ui.size.height);
            });

            return this;
            //});
        }
    };

    $.fn.selectMoneyFormat = function (method) {
        if (methods[method]) {
            return methods[method].apply(this, Array.prototype.slice.call(arguments, 1));
        } else if (typeof method === 'object' || !method) {
            return methods.init.apply(this, arguments);
        } else {
            $.error('Method ' + method + ' does not exist on jQuery.selectMoneyFormat');
        }
    };
})(jQuery);