﻿using System.ComponentModel.DataAnnotations;
using OpusSuite.Utility;
using OpusSuite.Globalisation.Attributes;

namespace OpusSuite.ViewModels.AccountAdmin
{
    public class SetupModel
    {
        [Required]
        [OpusDisplay(Enums.OpusSuiteResource.Common, "Username")]
        public string UserName { get; set; }

        [Required]
        [DataType(DataType.Password)]
        [OpusDisplay(Enums.OpusSuiteResource.Common, "Password")]
        public string Password { get; set; }

        [Required]
        [OpusDisplay(Enums.OpusSuiteResource.Common, "Database")]
        public string DatabaseName { get; set; }

        [Required]
        [OpusDisplay(Enums.OpusSuiteResource.Common, "Server")]
        public string ServerName { get; set; }

        [Required]
        [OpusDisplay(Enums.OpusSuiteResource.Common, "ServerType")]
        public Enums.ServerTypes ServerType { get; set; }

        [Required]
        [OpusDisplay(Enums.OpusSuiteResource.Common, "AdminUsername")]
        public string AdminUserName { get; set; }
    }
}